/////////////////////////////////////////////////////////////////////////////////////////////
//Explizite Flächen - directLight-Version
//3D-Darstellung verschiedener Gittern und Flächen Tasten: 0,1,2,...9
//Nächste Fläche: rechte Pfeiltaste , vorherige Fläche linke Pfeiltaste
//mit gedrückter Maustaste Drehung um x- und y-Achse 
//Zusätzlich Drehung um PI/16 um z-Achse: Taste z
// Wahl Farbkodierung: Tasten a,b,c,d,e
//Wahl Farbverlauf: Taste y : fester Farbverlauf, Taste x: zufälliger Farbverlauf
//Rein/raus-Zoomen: Tasten +,-
//Anzahl Gitterpunkte vergrößern/verkleinern: Tasten p,P
//Kleinerer DefBereich: Taste t
//Drehung um x-y-Achsen und um x-z-Achsen abwechseln: Taste q
//Begrenzungslinien der Quads einzeichnen: Taste l
//Hintergrund schwarz/weiß: Taste w
////////////////////////////////////////////////////////////////////////////////////////////////
float x,y; //EbeneneKoordinaten
float zW; //Zwischenwert
float z; //Höhe
float r,alpha;//Radius und Winkel
float r3D; //Radius im Raum
float winkelZ =0;
int anzahlX = 20;//Anzahl Pixel in x-Richtung (Fläche)
float xMin = -10;
float xMax =  10;

int anzahlY = 20;//Anzahl Pixel in y-Richtung (Fläche)
float yMin = -10;
float yMax =  10;

float zMin = 100;
float zMax =-100;
float rMax =   0;
float rMin = 100;
float r3DMax = 0;
float r3DMin = 100;
float scaleFaktor=24;

PVector[][] punkte ;//Punkte im Raum mit Pixelnummer
PVector[][] eKoordinaten;//Ebenen-Koordinaten berechnet aus Pixelnummern
  
float geoRotX = PI/4;
float geoRotY = 0;
float geoRotZ = 0;

float f=0;//hue-Wert
float F=0; //hue-Wert auf 0...255 gemappt
float G=0; //hue-Wert auf 0...1 gemappt
boolean raenderZeichnen;
boolean originalDefBer=true;//-10<x,y<10 - sonst 0<x,y<10
boolean hinterGrundSchwarz = true;
boolean zAchseDrehen = false;
int wahlFunktion;
int wahlFarbKodierung;
int wahlFarbVerlauf;//true, wenn zufälliger Farbverlauf gewählt wird
color farbeVon;
color farbeBis;
color farbe;
///////////////////////////////////////////////////////////////////////////////////////////
void setup() {
  size(800, 800, P3D);
  //smooth(8);
  colorMode(HSB);
  raenderZeichnen = true;
  punkte = new PVector[anzahlX+1][anzahlY+1];
  wahlFunktion =1;
  wahlFarbKodierung = 1;
  wahlFarbVerlauf = 1;
  raumPunkteBerechnen();
  farbeVon = color(random(255),random(150,255),random(150,255));
  farbeBis = color(random(255),random(150,255),random(150,255));
}

/////////////////////////////////////////////////////////////////////////////////////////////
void draw() {

  if(hinterGrundSchwarz)background(0);
  else background(255); 
   
  lightSpecular(0,200,200); //rot in HSB 
  directionalLight(0, 0, 255, -0.25, -0.25, 1); //weiß in HSB 
  directionalLight(0, 0, 255, 0.25, 0.25, -1); 
  specular(color(0,200,200)); //Oberflächen Reflexion rot
  shininess(15.0); 
   
  //Objekt in Bildmitte
  translate(width*0.5, height*0.5, 0); 
  scale(scaleFaktor);
  
  if (mousePressed){ 
      geoRotX = map(mouseY,0,height,0,-2*PI);//Rotation um die x-Achse
      geoRotY = map(mouseX,0,width,0,-2*PI); //Rotation um die y-Achse    
  }
  rotateX(geoRotX);
  rotateY(geoRotY);
  rotateZ(geoRotZ);
   
  if(zAchseDrehen){
    geoRotZ = geoRotZ+PI/16;
    println(geoRotX,geoRotY,geoRotZ);//Winkelinfo ausgeben
    zAchseDrehen = false;
  }
  gridZeichnen();
}
/////////////////////////////////////////////////////////////////////////////////////////////
void raumPunkteBerechnen(){
  
  for (int iy = 0; iy <= anzahlY; iy++) {    
     for (int ix = 0; ix <= anzahlX; ix++) {
         x = map(ix, 0, anzahlX, xMin, xMax);
         y = map(iy, 0, anzahlY, yMin, yMax);//Pixel(ix,iy) auf eKoordinatensystem (x,y) abbilden
         punkte[ix][iy] = new PVector();//enthält die unveränderten x und y eKoordinaten
         punkte[ix][iy].x = x;
         punkte[ix][iy].y = y;
         r = sqrt(x*x + y*y);//Abstand vom Ursprung in der Ebene
         
         switch(wahlFunktion){
         case 1://Wellen radial mit zentraler Spitze         
              punkte[ix][iy].z =  6* cos(1.5*r)/(r+1);
              r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
              if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
              if(r3D<r3DMin) r3DMin = r3D;
              if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
              if(r<rMin) rMin = r;
              if(x!=0 && y!=0){//bei (0,0) Sprung auf zMax =6 (sonst 1,165)
                if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
                if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen    
              }
              break;
          case 2://ähnlich (1) - aber nicht punktsymmetrisch
              if(r!=0) alpha=asin(y/r);
              else alpha=0;;
              punkte[ix][iy].z = 8* cos(1.5*r)/(r+1) + 0.05*x*y - 0.01*x*x + 0.01*y*y + 2*abs(sin(2*alpha));
              r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
              if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
              if(r3D<r3DMin) r3DMin = r3D;
              if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
              if(r<rMin) rMin = r;
              if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
              if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
              break;
          case 3://wie (1)- aber Wellen moduliert           
              if(r!=0) alpha=asin(y/r);
              else alpha=0;;
              if(r>2) punkte[ix][iy].z = 8*cos(r)*sin(12*alpha+PI/2)/(r+1);
              else punkte[ix][iy].z = 8*cos(r)/(r+1);
              r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
              if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
              if(r3D<r3DMin) r3DMin = r3D;
              if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
              if(r<rMin) rMin = r; //println(rMin,rMax);
              if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
              if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
              break;
          case 4://wie (3) - aber Wellen mehrfach moduliert und ohne zentrale Spitze
               if(r!=0) alpha=asin(y/r);
               else alpha=0;;
               punkte[ix][iy].z = 0.06*r*r*cos(0.8*r)*cos(12*alpha);
               r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
               if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
               if(r3D<r3DMin) r3DMin = r3D;
               if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
               if(r<rMin) rMin = r;
               if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
               if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
               break;         
          case 5://wie (3) aber Wellen nicht in einer Ebene (hyperbolisch)
               if(r!=0) alpha=asin(y/r);
               else alpha=0;;
               punkte[ix][iy].z  = 0.003*(x*y+2*x*x*y-2*x*y*y)+ 6*cos(1.5*r)*cos(16*alpha)/(r+1);
               r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
               if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
               if(r3D<r3DMin) r3DMin = r3D;
               if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
               if(r<rMin) rMin = r;
               if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
               if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
               break;                 
          case 6://"Fallschirm"
               if(r!=0) alpha=asin(y/r);
               else alpha=0;;
               punkte[ix][iy].z  = 0.05*(36-r*r)+8-2*sin(6*alpha);;
               r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
               if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
               if(r3D<r3DMin) r3DMin = r3D;
               if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
               if(r<rMin) rMin = r;
               if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
               if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
                break;  
          case 7://Hyperbolischer Paraboloid            
               punkte[ix][iy].z = sq(y)/16-sq(x)/9;
               r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
               if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
               if(r3D<r3DMin) r3DMin = r3D;
               if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
               if(r<rMin) rMin = r;
               if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
               if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
                break;  
          case 8://halbes Ellipsoid             
               punkte[ix][iy].z = 10*sqrt(1-(sq(x)/16+sq(y)/49));
               r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
               if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
               if(r3D<r3DMin) r3DMin = r3D;
               if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
               if(r<rMin) rMin = r;
               if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
               if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
                break;                   
          case 9://halbe Sphäre
               punkte[ix][iy].x = x;
               punkte[ix][iy].y = y;
               if(-sq(x)-sq(y)+25 >=0)punkte[ix][iy].z = sqrt(-sq(x)-sq(y)+25);
               else punkte[ix][iy].z = 0;
               r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
               if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
               if(r3D<r3DMin) r3DMin = r3D;
               if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
               if(r<rMin) rMin = r;
               if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
               if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
               break;        
         }
     }   
  }
}
/////////////////////////////////////////////////////////////////////////////////////////////
void keyPressed(){
  if(key == 'l'){//abwechseln zwischen Gitter und Fläche
     raenderZeichnen=!raenderZeichnen;
     standardWerteEinstellen();
  }
  if(key == 'w'){
     hinterGrundSchwarz = !hinterGrundSchwarz;
  }
  if(key == 'z'){//z-Achsen Drehung PI/16 
    zAchseDrehen=true;
  }
  //expliz. Funktion wählen
  if(key == '1') {
     wahlFunktion = 1;
     standardWerteEinstellen();
  }
  if(key == '2') {
     wahlFunktion = 2;
     standardWerteEinstellen();
  }
  if(key == '3') {
     wahlFunktion = 3;
     standardWerteEinstellen();
  }
  if(key == '4') {
     wahlFunktion = 4;
     standardWerteEinstellen();
   }
  if(key == '5') {
     wahlFunktion = 5;
     standardWerteEinstellen();
  }
  if(key == '6') {
     wahlFunktion = 6;
     standardWerteEinstellen();
  } 
  if(key == '7') {
     wahlFunktion = 7;
     standardWerteEinstellen();
  } 
  if(key == '8') {
     wahlFunktion = 8;
     standardWerteEinstellen();
  }
  if(key == '9') {
     wahlFunktion = 9;    
     standardWerteEinstellen();
  }
  //nächste expliz. Funktion wählen
  if(key == CODED){
    if(keyCode == RIGHT)
       wahlFunktion= (wahlFunktion +1)%10;
       standardWerteEinstellen();    
  }
  if(key == CODED){
    if(keyCode == LEFT)
       if(wahlFunktion>=1)wahlFunktion = wahlFunktion -1;
       if(wahlFunktion==0)wahlFunktion= 9;
       standardWerteEinstellen();    
  }
  if(key == 'a') wahlFarbKodierung =1;  
  if(key == 'b') wahlFarbKodierung =2;  
  if(key == 'c') wahlFarbKodierung =3;
  if(key == 'd') wahlFarbKodierung =4;
  if(key == 'e') wahlFarbKodierung =5;
  if(key == 'y') wahlFarbVerlauf =1;  
  if(key == 'x') {
    wahlFarbVerlauf =2;
    farbeVon = color(random(255),random(150,255),random(150,255));
    farbeBis = color(random(255),random(150,255),random(150,255));   
  } 
  
  
  if(key == '+'){    
     scaleFaktor = 1.2*scaleFaktor;    
     anzahlX = round(1.2*(float)anzahlX);
     anzahlY = round(1.2*(float)anzahlY);println("Aktuelle Werte für ScaleFaktor, anzahlX, anzahlY +: "+scaleFaktor,anzahlX,anzahlY);
     punkte = new PVector[anzahlX+1][anzahlY+1];
     eKoordinaten = new PVector[anzahlX+1][anzahlY+1];
     raumPunkteBerechnen();    
  }
  if(key == '-'){
     scaleFaktor = 1/1.2*scaleFaktor;
     anzahlX = round(1/1.2*(float)anzahlX);
     anzahlY = round(1/1.2*(float)anzahlY);println("Aktuelle Werte für ScaleFaktor, anzahlX, anzahlY +: "+scaleFaktor,anzahlX,anzahlY);
     punkte = new PVector[anzahlX+1][anzahlY+1];
     raumPunkteBerechnen();    
  }
  if(key == 'p'){   //Anzahl der Gitterpunkte *1.5 
     anzahlX = round(1.2*(float)anzahlX);
     anzahlY = round(1.2*(float)anzahlY);println("Aktuelle Werte für ScaleFaktor, anzahlX, anzahlY +: "+scaleFaktor,anzahlX,anzahlY);
     punkte = new PVector[anzahlX+1][anzahlY+1];
     eKoordinaten = new PVector[anzahlX+1][anzahlY+1];
     raumPunkteBerechnen();    
  }
  if(key == 'P'){   //Anzahl der Gitterpunkte /1.5 
     anzahlX = round(1/1.2*(float)anzahlX);
     anzahlY = round(1/1.2*(float)anzahlY);println("Aktuelle Werte für ScaleFaktor, anzahlX, anzahlY +: "+scaleFaktor,anzahlX,anzahlY);
     punkte = new PVector[anzahlX+1][anzahlY+1];
     eKoordinaten = new PVector[anzahlX+1][anzahlY+1];
     raumPunkteBerechnen();    
  } 
  if(key == 't'){
     originalDefBer = !originalDefBer;
     standardWerteEinstellen();
     raumPunkteBerechnen();     
  }
  if (key == 's'){
    saveFrame("explFlaeche##.png");
  }
 
}
/////////////////////////////////////////////////////////////////////////////////////
void standardWerteEinstellen(){
     zMin = 100;
     zMax =-100;//Initialisierung 
     rMax = 0; r3DMax = 0;
     rMin = 100; r3DMin = 100;
     scaleFaktor =24;     
     anzahlX = 20; anzahlY=20;
    
     punkte = new PVector[anzahlX+1][anzahlY+1];
     if(originalDefBer){//"originaler Definitionsbereich"
         xMin = -10; xMax = 10;
         yMin = -10; yMax = 10;
     }else{//angepasster Definitionsbereich 
       xMin = 0; xMax = 20;//hier gewünschten alternativen Bereich wählen (nicht für 7 und 9)
       yMin = 0; yMax = 20;
       if(wahlFunktion==7){
         xMin = 0; xMax = 0.5;
         yMin = 0; yMax = 5;
       }       
       if(wahlFunktion==9){
         anzahlX = 40; anzahlY=40;
         xMin =   -6; xMax = 6;
         yMin =   -6; yMax = 6;
       }
     } 
     raumPunkteBerechnen();
}

/////////////////////////////////////////////////////////////////////////////////////////////
void gridZeichnen() {
   strokeWeight(1/scaleFaktor);
   if(raenderZeichnen) stroke(1);
    else noStroke();
     
   for (int iy = 0; iy < anzahlY; iy++) {    
    beginShape(QUAD_STRIP);   
    for (int ix = 0; ix < anzahlX; ix++) {
       switch(wahlFarbKodierung){
           case 1://x-y-Radius abhängig
              f = sqrt(sq(punkte[ix][iy].x)+sq(punkte[ix][iy].y));
              F = map(f,rMin,rMax,0,255);
              G = map(f,rMin,rMax,0,1);
              if(wahlFarbVerlauf == 1) fill(F,255,255);
              if(wahlFarbVerlauf == 2){
                  farbe = lerpColor(farbeVon,farbeBis,G);///println(F,F*0.0039);
                  fill(farbe);
              }
              break;
              
           case 2://Höhenabhängig
              f = punkte[ix][iy].z;//Höhe
              F = map(f,zMin,zMax,0,255); if(F<0) F=0;
              G = map(f,rMin,rMax,0,1);
              if(wahlFarbVerlauf == 1)fill(F,255,255);
              if(wahlFarbVerlauf == 2){
                  G = map(f,zMin,zMax,0,1); 
                  farbe = lerpColor(farbeVon,farbeBis,G);//println(hue(farbe),G);
                  fill(farbe);
              }
              break;     
              
          case 3://weiß
              fill(0,0,255);
              break;
              
         case 4: //Winkelabhängig       
              f =255*(180+degrees(atan2(punkte[ix][iy].y,punkte[ix][iy].x)))/360; //auf 0-255 gemappt  
              fill(f,255,255);
              break;
              
         case 5: //x-y-z Radius abhängig
              f=  sqrt(sq(punkte[ix][iy].x)+sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
              F = map(f,r3DMin,r3DMax,0,255); //if(F<130)print(F+" ");
              G = map(f,r3DMin,r3DMax,0,1);//println(farbFaktor,f,F);
              if(wahlFarbVerlauf == 1) fill(F,255,255);
              if(wahlFarbVerlauf == 2){
                  farbe = lerpColor(farbeVon,farbeBis,G);///println(F,F*0.0039);
                  fill(farbe);
              }
        }
      vertex(punkte[ix][iy].x , punkte[ix][iy].y , punkte[ix][iy].z );  
      vertex(punkte[ix][iy+1].x , punkte[ix][iy+1].y , punkte[ix][iy+1].z ); 
    }
    endShape();
  }  
}
